/*
 * ProgressBar.java
 *
 * Created on October 21, 2008, 11:43 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package Drag_n_Drop;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 * This class is extending JDialog class and implementing Runnable interface
 * to create the progress bar window during sending or receiving.
 */
public class ProgressBar extends JDialog implements Runnable {
    //progress bar
    public JProgressBar pb;
    //Show processed and total data size.
    public JTextField jft;
    ////indicate whether it is a sending bar (index=1) or receiving bar(index=1).
    public static int index;
    /** Creates a new instance of ProgressBar */
    public ProgressBar(String type) {
        index=0;
        String a="";
        if(type.equals("send")){
            pb =new JProgressBar(0,Send.length_file);
            index=1;
            a=new String(Send.length_file+" of "+Send.length_file +" finished");
        }
        else if(type.equals("receive")){
            pb =new JProgressBar(0,Receive.file_length);
            index=2;
            a=new String(Receive.file_length+" of "+Receive.file_length +" finished");
        }
        jft=new JTextField(a.length());
        jft.setHorizontalAlignment(JTextField.CENTER);
        jft.setEditable(false);
        Container contentPane=getContentPane();
        //initiate the bar
        pb.setValue(0);
        pb.setSize(250, 50);
        pb.setStringPainted(true);
        JPanel panel = new JPanel();
        JPanel panel2 = new JPanel();
        this.addWindowListener(new CloseHandler());// add window listener for closing event
        JButton button=new JButton("Cancel");
        final JDialog jd=this;
        //Cancel the transfer.
        button.addActionListener(new ActionListener(){
                    public void actionPerformed(ActionEvent e){
                        if(index==1){
                            Send.send_stop=true;
                        }
                        else if(index==2){
                            Receive.receive_stop=true;
                        }
                        //close the process bar window.
                        jd.dispose();
                }
            }
        );
        panel.add(pb);
        panel2.add(jft);
        panel2.add(button);
        contentPane.add(panel);
        contentPane.add(panel2);
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));//.setLayout(new FlowLayout());
        panel.setVisible(true);
        panel2.setVisible(true);
        setContentPane(contentPane);
    }
    /**
     * Run method of the thread, used to update the value of the process bar.
     */
    public void run(){
        //update the bar states, stop if sending/receiving finishes
        while((!Send.sent_finish&&index==1)||(!Receive.receive_finish&&index==2)){
            if(index==1){
              pb.setValue(Send.length_sent);
              jft.setText(Receive.bytesToDisplay(Send.length_sent)+" of "+Receive.bytesToDisplay(Send.length_file)+" finished");
            }
            else if(index==2){
              pb.setValue(Receive.length_received);
              jft.setText(Receive.bytesToDisplay(Receive.length_received)+" of "+Receive.bytesToDisplay(Receive.file_length)+" finished");
            }
        }
        this.setVisible(false);
        return;
    }
    /**
     * This inner class is used to handle the window close event which indicates user
     * cancel the transfer or receiving.
     */
    protected static class CloseHandler extends WindowAdapter{// user cancel the progress

            public void windowClosing (final WindowEvent event){
                try{
                   if(index==1){
                        Send.send_stop=true;
                   }
                   if(index==2){
                        Receive.receive_stop=true;
                   }
                }
                catch(Exception e){}
                
                //System.exit(0);

            }

   }
}
