package Drag_n_Drop; 
import java.net.*;
import java.io.*;
import javax.swing.*;
/**
 * Run as a thread to receive file and handle exceptions during transfer.
 * Create instance of ReceiveBar to show sending progress.
 * @see  ReceiveBar
 */
public class Receive implements Runnable {
        //default file saving directory
        public static String saveDirectory="";
        //file name received
        public static String displayFileName;
        //sender's host name and port name
        public static String sender_host;
        //data has been received
        public static int length_received=0;
        //total file length
        public static int file_length=0;
        // indicate whether the receiving is finished(not means successful)
        public static boolean receive_finish=false;
        //TCP service socket
        public static ServerSocket server;
        //indicate if the user stop receiving
        public static boolean receive_stop=false;
   	public Receive() {
		(new Thread(this)).start();
	}
        /**
         * Change the bytes number to readable file length.
         * @param bytesLength  byte number of the file
         * @return             readable file length
         */
        public static String bytesToDisplay(int bytesLength){
                  int KB=1024;
                  String readSize="";
                  if (bytesLength/(KB*KB*KB)>0) {
                      readSize+= String.valueOf(bytesLength/(KB*KB*KB)) + "GB";
                  } 
                  else if(bytesLength/(KB*KB)>0) {
                       readSize+= String.valueOf(bytesLength/(KB*KB)) + "MB";
                  } 
                  else if(bytesLength/(KB)>0) {
                        readSize+= String.valueOf(bytesLength/(KB)) + "KB";
                  }
                  else{
                        readSize+= String.valueOf(bytesLength) + "bytes";
                  }
                  return readSize; 
        }
        /**
         * Run method receives the file.
         * Create intance of ReceiveBar to show progressbar during transfer.
         * @see  ReceiveBar
         */
	public void run() {
           File file, tmpFile;
           // input stream for data packets
           InputStream in;
           DataInputStream in_from_sender;
           OutputStream output = System.out;
           //ouput stream to write data to file
           OutputStream out;
           //ouptut stream to sender
           OutputStream out_to_sender;
           //buffer size to receive the data
           int BUFFER_SIZE=320;
           // Loop indefinitely, accepting clients
           boolean first=true;
           JFileChooser fc;
           for (;;){
              try{
                  fc = new JFileChooser(this.saveDirectory);
                  FileXchange.send_lock=false;
                  if(first){
                    server = new ServerSocket(FileXchange.service_port);
                    first=false;
                  }
                  // Get the next TCP client
                  Socket nextClient = server.accept();
                  while(FileXchange.send_lock){
                  }
                  //Stream for control data.
                  in_from_sender=new DataInputStream(nextClient.getInputStream());
                  //Stream for file data.
                  in= new BufferedInputStream(nextClient.getInputStream());
                  //Stream for sending response.
                  out_to_sender=nextClient.getOutputStream();//new BufferedOutputStream(nextClient.getOutputStream());
                  byte[] buffer = new byte[BUFFER_SIZE];
            	  //Initiate parameters.
                  int nBytes=0;
                  length_received=0;
                  file_length=0;
                  receive_finish=false;
                  receive_stop=false;
                  //set timeout value to detect the sender's behavior
                  nextClient.setSoTimeout(10000);
                  displayFileName=in_from_sender.readUTF();//in_from_sender.r.readLine();//filename
                  sender_host=in_from_sender.readUTF();//host name of sender
                  //file_length=Integer.valueOf(in_from_sender.readUTF());//file length
                  String l=new String(in_from_sender.readUTF());
                  file_length=Integer.valueOf(l);
                  int choose=JOptionPane.showConfirmDialog(FileXchange.f,"Transfer accepted--"+displayFileName +"("+bytesToDisplay(file_length)+")"+" by " +sender_host+"\nClick OK to accept it.","Transfer Accpeted",JOptionPane.OK_CANCEL_OPTION);
                  // If not accept, abort.
                  if(choose!=0){
                       out_to_sender.write(2);
                       out_to_sender.close();
                       continue;
                  }
                  boolean decided=false;
                  //chose the saving path.
                  while(!decided){
                  fc.setSelectedFile(new File(displayFileName));
                  int returnVal = fc.showSaveDialog(null);
                  // select path to save the file if accept
                  if (returnVal == JFileChooser.APPROVE_OPTION) {
                      file = fc.getSelectedFile();
                      boolean exist=false;
                      try{
                        FileInputStream fis=new FileInputStream(file.getAbsolutePath());
                        exist=true;
                      }
                      catch(Exception e){
                      }
                      if(exist==true){
                         int choose2=JOptionPane.showConfirmDialog(FileXchange.f,"File exists! Do you want to overwrite '"+displayFileName+"' in '"+file.getAbsolutePath().replace(displayFileName,"")+"'?","File Existed",JOptionPane.OK_CANCEL_OPTION);
                         if(choose2!=0){
                            continue;
                         }
                         File f = new File(file.getAbsolutePath());
                         if(!f.canWrite()){
                            JOptionPane.showMessageDialog(FileXchange.f,"file '"+file.getName()+"' is non-writable");
                            continue;
                         }
                      }
                      decided=true;
                      //change the default saving path
                      if(file.getAbsolutePath()!=this.saveDirectory){
                         this.saveDirectory=file.getAbsolutePath();
                         try{ 
                            FileReader fr=new FileReader("config.ini");
                            BufferedReader br=new BufferedReader(fr);
                         
                        
                        }
                         catch(Exception ee){
                            File newf = new File("config.ini"); 
                            newf.createNewFile();
                         }
                         try{
                            FileWriter fw=new FileWriter("config.ini");
                            BufferedWriter bf = new BufferedWriter(fw); 
                            String str="File saving directroy="+this.saveDirectory;
                            bf.write(str);
                            bf.close();
                            fw.close();
                         }
                         catch(Exception ee2){}
                      
                      }
                      tmpFile = new File (file.getAbsolutePath() + ".tmp");
                      output = new FileOutputStream(tmpFile);
                      out =new BufferedOutputStream(output);
                      buffer = new byte[BUFFER_SIZE];
                      out_to_sender.write(1);//write signal to sender to inform acceptance
                      //online=true;
                      try{
                          //start the receiving progress bar
                          ReceiveBar receiveBar=new ReceiveBar();
                          receiveBar.start();
                          //start receiving data, stop when reaching the end of the stream or user cancellation or timeout
                          while (!receive_stop) {
                              nBytes=in.read(buffer, 0, BUFFER_SIZE);
                              if (nBytes < 0){//end of the stream
                                     break;
                              }
                              out.write(buffer, 0, nBytes);
                              length_received+=nBytes;
                              if(length_received==file_length){
                                  System.out.println("complete");
                                  receive_finish=true;
                                  break;
                              }
                          }
                      }
                      //catch exception during data packets transfer
                      catch(Exception e){
                            JOptionPane.showMessageDialog(FileXchange.f,"Transfer of file '"+displayFileName+"' failed. \r\nThere was noresponse from the sender - it might have left the network, or canceled transfer.");                          in.close();
                             out_to_sender.close();
                             out.flush();
                             out.close();
                             tmpFile.delete();
                             receive_finish=true;
                             continue;
                      }
                      in.close();
                      out_to_sender.close();
                      out.flush();
                      out.close();
                      if(length_received<file_length){
                         tmpFile.delete();
                         if(!receive_stop)
                           JOptionPane.showMessageDialog(FileXchange.f,"Transfer of file '"+displayFileName+"' failed. \r\nThere was noresponse from the sender - it might have left the network, or canceled transfer.");
                         else
                           JOptionPane.showMessageDialog(FileXchange.f,"You cancelled receiving of '"+displayFileName+"' from "+this.sender_host+"!");
                         receive_finish=true;
                         continue;
                         
                      }
                      
                      tmpFile.renameTo(file);//rename the tmp file to delete the extention '.tmp'
                   }
                  //decline the file
                  if (returnVal != JFileChooser.APPROVE_OPTION){
                      decided=true;
                      out_to_sender.write(2);
                      out_to_sender.close();
                      
                  }
                }
                  // Close the connection
                  nextClient.close();
             }
        catch (BindException be){
             System.err.println ("Service are already running on port " + FileXchange.service_port );
             return;
        }
        //catch exception during control packets transfer
        catch(Exception e){
                 JOptionPane.showMessageDialog(FileXchange.f,"Transfer of file '"+displayFileName+"' failed. \r\nThere was noresponse from the sender - it might have left the network, or canceled transfer.");
                 receive_finish=true;
                 continue;
        }
      }
        
    }
}
/**
 * Create instance of ProgressBar to show progress during receiving.
 * @see ProgressBar
 */
class ReceiveBar extends Thread{//start receiving progress bar
    public ProgressBar pbd;
    public void run(){
        pbd=new ProgressBar("receive");
        pbd.setSize(300,150);
        pbd.setLocation(FileXchange.f.getLocation());
        pbd.setTitle("receiving "+ Receive.displayFileName+" from "+ Receive.sender_host);
        pbd.setVisible(true);
        pbd.run();
    }
}

